﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Dayu C# Version 1.02
Replacing katakana with ASCII according to sortk.txt
Copyright 2019 Sogaya

Visual C# 2008 Express
Visual Studio 2010

Dayu assumes that the little-endian architecture underlies operating systems (Linux, Windows).
*/

namespace Dayu
{
    class Program
    {
        static void Main(string[] args)
        {
            const bool REMOVE_ANCIENT_FILE = false;
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.02;
            const int ERROR_CODE = 1;
            const string ACQUIRE_TABLE_NAME_FROM_TEXT = "-q";
            const string ASCII = "-a";
            const string CRLF = "-CRLF";
            const string DAYU_TEXT = "Dayu.txt";
            const string DIFFERENT_TIME = "-t-";
            const string DO_NOT_REMOVE_0DH = "-L-";
            const string DO_NOT_REMOVE_TEMPORARY_BINARY_FILE = "-y";
            const string DO_NOT_SEARCH_TABLE = "-d";
            const string DO_NOT_SHOW_WHICH_TABLE_IS_ACCESSIBLE = "-w-";
            const string EMPTY = "";
            const string IDENTICAL_TIME = "-t";
            const string KATAKANA = "-k";
            const string LF = "-LF";
            const string LINE_FEED = "-L";
            const string LIST_FILE = "-f";
            const string MS932 = "-m";
            const string MS932_SJIS_BIN = "MS932~Shift_JIS.bin";
            const string NO_EDITING = "-e-";
            const string NO_READING = "-r-";
            const string NO_SKIPPING = "-i-";
            const string SEARCH_TABLE = "-d-";
            const string SETTING_TEXT = "twenty.txt";
            const string SHIFT_JIS = "-s";
            const string SKIPPING = "-i";
            const string TEMPORARY_BINARY = "binary.tmp";
            const string TEMPORARY_BINARY_FILE = "-b";
            const string VERSION_WITH_COMMENTS = "-VC";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string WHICH_TABLE = "-w";

            bool carriage_return = true;
            bool document_to_be_read = true;
            bool edit_table = true;
            bool list_to_be_read = false;
            bool identical_time = false;
            bool no_removing = false;
            bool no_searching = false;
            bool produce_binary_file = false;
            bool result = true;
            bool no_reading = false;
            bool selected_directory_has_priority = false;
            bool skip_control_characters = false;
            bool which_table = false;
            Guide g = new Guide();
            int exit_code = 0;
            int file_name_size = 0;
            string binaryName = MS932_SJIS_BIN;
            string binary_name_has_priority = MS932_SJIS_BIN;
            string document_name = EMPTY;
            string head = EMPTY;
            string new_name = DAYU_TEXT;
            string text_of_substitutes_list = EMPTY;
            string normal = "⑳"; // 8753h
            string substitute = "廿"; // 93F9h

// Acquiring parameters from SETTING_TEXT unless the user removes it.
            AcquireFromText a = new AcquireFromText(SETTING_TEXT, binaryName, binary_name_has_priority, document_name, new_name, normal, substitute, text_of_substitutes_list, produce_binary_file, carriage_return, no_searching, edit_table, skip_control_characters, no_reading, identical_time, which_table, no_removing);
            a.acquiring();
            binary_name_has_priority = a.priority();
            binaryName = a.binaryName();
            carriage_return = a.carriageReturn();
            document_name = a.textName();
            edit_table = a.editTable();
            identical_time = a.identicalTime();
            new_name = a.newName();
            no_reading = a.noReading();
            no_removing = a.noRemoving();
            no_searching = a.noSearching();
            normal = a.normalCharacter();
            produce_binary_file = a.produceBinary();
            skip_control_characters = a.skipping();
            substitute = a.substituteCharacter();
            text_of_substitutes_list = a.substitutesList();
            which_table = a.whichTable();

            foreach (string argument in args)
            {
                switch (argument)
                {
                    case ACQUIRE_TABLE_NAME_FROM_TEXT:
                        selected_directory_has_priority = true;
                        break;
                    case CRLF:
                        carriage_return = true;
                        break;
                    case DIFFERENT_TIME:
                        identical_time = false;
                        break;
                    case DO_NOT_REMOVE_0DH:
                        carriage_return = true;
                        break;
                    case DO_NOT_REMOVE_TEMPORARY_BINARY_FILE:
                        no_removing = true;
                        break;
                    case DO_NOT_SEARCH_TABLE:
                        no_searching = true;
                        break;
                    case DO_NOT_SHOW_WHICH_TABLE_IS_ACCESSIBLE:
                        which_table = false;
                        break;
                    case IDENTICAL_TIME:
                        identical_time = true;
                        break;
                    case LINE_FEED:
                        carriage_return = false;
                        break;
                    case LF:
                        carriage_return = false;
                        break;
                    case LIST_FILE:
                        list_to_be_read = true;
                        break;
                    case NO_EDITING:
                        edit_table = false;
                        break;
                    case NO_READING:
                        no_reading = true;
                        break;
                    case NO_SKIPPING:
                        skip_control_characters = false;
                        break;
                    case SEARCH_TABLE:
                        no_searching = false;
                        break;
                    case SKIPPING:
                        skip_control_characters = true;
                        break;
                    case TEMPORARY_BINARY_FILE:
                        produce_binary_file = true;
                        break;
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case WHICH_TABLE:
                        which_table = true;
                        break;
                    default:
                        head = argument.Substring(0, 2);
                        switch (head)
                        {
                            case ASCII:
                                substitute = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            case SHIFT_JIS:
                                substitute = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            case KATAKANA:
                                normal = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            case MS932:
                                normal = argument.Substring(2, 1);
                                list_to_be_read = false;
                                break;
                            default:
                                if (list_to_be_read)
                                {
                                    text_of_substitutes_list = argument;
                                    list_to_be_read = false;
                                }
                                else
                                {
                                    if (document_to_be_read)
                                    {
                                        document_name = argument;
                                        document_to_be_read = false;
                                    }
                                    else
                                    {
                                        new_name = argument;
                                    }

                                } // if (list_to_be_read), else

                                break;
                        } // switch (head)

                        break;
                } // switch (argument)

            } // foreach (string argument in args)

            SearchTable s = new SearchTable(binaryName, no_searching, selected_directory_has_priority, which_table);
            if (edit_table)
            {
// Editing
                Editing e = new Editing();

                if (text_of_substitutes_list.Length == 0)
                {
                    result = e.editRecord(s, normal, substitute, binaryName, no_removing);
                }
                else
                {
                    result = e.editManyRecords(s, text_of_substitutes_list, binaryName, no_removing);
                }

                if (result)
                {
                    if (no_reading)
                    {
                        System.Environment.Exit(0);
                    }

                }
                else
                {
                    System.Environment.Exit(ERROR_CODE);
                }

            }

// Regulating
            file_name_size = document_name.Length;
            if (file_name_size == 0)
            {
                StandardInput i = new StandardInput(s);

                if (skip_control_characters)
                {
                    exit_code = i.standard_input_output_skipping();
                }
                else
                {
                    exit_code = i.standard_input_output();
                }

            }
            else
            {
                Regulate r = new Regulate(s, document_name);

                if (identical_time)
                {
                    r.produceBinaryFile(document_name, REMOVE_ANCIENT_FILE);
                    r.renameBinaryFile(document_name, no_removing);
                }

                if (carriage_return)
                {
                    if (produce_binary_file)
                    {
                        if (skip_control_characters)
                        {
                            exit_code = r.skippingControlCharactersToProduceSJIS(TEMPORARY_BINARY);
                        }
                        else
                        {
                            exit_code = r.readingToProduceSJIS(TEMPORARY_BINARY);
                        }

                        r.renameBinaryFile(new_name, no_removing);
                    }
                    else
                    {
                        if (skip_control_characters)
                        {
                            exit_code = r.skippingControlCharactersToProduceSJIS(new_name);
                        }
                        else
                        {
                            exit_code = r.readingToProduceSJIS(new_name);
                        }

                    }

                }
                else
                {
                    if (produce_binary_file)
                    {
                        if (skip_control_characters)
                        {
                            exit_code = r.skippingControlCharactersToProduceSJIS_LF(TEMPORARY_BINARY);
                        }
                        else
                        {
                            exit_code = r.readingToProduceSJIS_LF(TEMPORARY_BINARY);
                        }

                        r.renameBinaryFile(new_name, no_removing);
                    }
                    else
                    {
                        if (skip_control_characters)
                        {
                            exit_code = r.skippingControlCharactersToProduceSJIS_LF(new_name);
                        }
                        else
                        {
                            exit_code = r.readingToProduceSJIS_LF(new_name);
                        }

                    } // if (produce_binary_file), else

                } // if (carriage_return), else

            } // if (file_name_size == 0), else

            System.Environment.Exit(exit_code);
        }

    }
}
