﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

/*
Rufeol C# Version 1.02
Copyright 2019 Sogaya
Removing unnecessary characters from every end of line
RUFEOL (Removing Unnecessary characters From every End Of Line)

Visual C# 2008 Express
Visual Studio 2010

*/

namespace Rufeol
{
    class Program
    {
        static void Main(string[] args)
        {
            const bool WITH_COMMENTS = true;
            const bool WITHOUT_COMMENTS = false;
            const double VERSION = 1.02;
            const int BUFFER_SIZE = 524288; // 512 KB
            const int ERROR_CODE = 1;
            const int FULL_LEVEL = 1;
            const int NOT_CONVERTED = -1;
            const int NOT_FOUND = -1;
            const int TAIL_LENGTH = 1;
            const string CARRIAGE_RETURN = "-r";
            const string CRLF = "-CRLF";
            const string DO_NOT_REMOVE_TEMPORARY_BINARY_FILE = "-y";
            const string DOUBLE_SPACED = "-x";
            const string EMPTY = "";
            const string HELP = "--help";
            const string LEVEL_TERM = "-w";
            const string MONOLITHIC = "-m";
            const string RUFEOL_TEXT = "draft.txt";
            const string UNNECESSARY = "-u";
            const string VERSION_WITHOUT_COMMENTS = "-V";
            const string VERSION_WITH_COMMENTS = "-VC";

            bool carriageReturn = false;
            bool file_to_be_read = true;
            bool no_removing = false;
            bool result = true;
            Guide g = new Guide();
            int bufferSize = BUFFER_SIZE;
            int exit_code = 0;
            int fullLevel = FULL_LEVEL;
            int q = NOT_FOUND;
            int unnecessaryWidth = TAIL_LENGTH;
            Numbered n;
            string fileName = EMPTY;
            string newName = RUFEOL_TEXT;

            foreach (string s in args)
            {
                switch (s)
                {
                    case CARRIAGE_RETURN:
                        carriageReturn = true;
                        break;
                    case CRLF:
                        carriageReturn = true;
                        break;
                    case DO_NOT_REMOVE_TEMPORARY_BINARY_FILE:
                        no_removing = true;
                        break;
                    case HELP:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case MONOLITHIC:
                        carriageReturn = true;
                        unnecessaryWidth = 2;
                        break;
                    case VERSION_WITH_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITH_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    case VERSION_WITHOUT_COMMENTS:
                        exit_code = g.versionGuide(VERSION, WITHOUT_COMMENTS);
                        System.Environment.Exit(exit_code);
                        break;
                    default:
                        q = s.IndexOf(DOUBLE_SPACED);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            fullLevel = n.number();
                            if (DOUBLE_SPACED.CompareTo(n.parameter()) == 0)
                            {
                                if (fullLevel == NOT_CONVERTED)
                                {
                                    fullLevel = FULL_LEVEL;
                                }

                                carriageReturn = true;
                                unnecessaryWidth = fullLevel * 2 - 1;
                                continue;
                            }

                            fullLevel = FULL_LEVEL;
                        }

                        q = s.IndexOf(LEVEL_TERM);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            fullLevel = n.number();
                            if (LEVEL_TERM.CompareTo(n.parameter()) == 0)
                            {
                                if (fullLevel == NOT_CONVERTED)
                                {
                                    fullLevel = FULL_LEVEL;
                                }

                                continue;
                            }

                            fullLevel = FULL_LEVEL;
                        }

                        q = s.IndexOf(UNNECESSARY);
                        if (q == 0)
                        {
                            n = new Numbered(s);
                            unnecessaryWidth = n.number();
                            if (UNNECESSARY.CompareTo(n.parameter()) == 0)
                            {
                                if (unnecessaryWidth == NOT_CONVERTED)
                                {
                                    unnecessaryWidth = TAIL_LENGTH;
                                }

                                continue;
                            }

                            unnecessaryWidth = TAIL_LENGTH;
                        }

                        if (file_to_be_read)
                        {
                            fileName = s;
                            file_to_be_read = false;
                        }
                        else
                        {
                            newName = s;
                        }

                        break;
                } // switch (s)

            } // foreach (string s in args)

            if (fileName.Length == 0)
            {
                Console.Error.WriteLine("fileName.Length == 0 error");
                System.Environment.Exit(ERROR_CODE);
            }

            RemoveFromLine r = new RemoveFromLine(fileName, bufferSize, fullLevel, unnecessaryWidth);
            if (carriageReturn)
            {
                result = r.insertCRLF();
            }
            else
            {
                result = r.insertLF();
            }

            if (result)
            {
                exit_code = r.renameBinaryFile(newName, no_removing);
            }
            else
            {
                exit_code = ERROR_CODE;
            }

            System.Environment.Exit(exit_code);
        }

    }
}
