﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace Sortk
{
    class PutText
    {
        const bool NO_APPENDING = false;
        const int NOT_CONVERTED = -1;
        const string EMPTY = "";
        const string ZERO = "0";

        private int sequence_to_integer(string s)
        {
            int a = NOT_CONVERTED;
            try
            {
                a = Convert.ToInt32(s);
            }
            catch (FormatException e518)
            {
                Error.handler(e518.ToString());
            }
            catch (Exception e519)
            {
                Error.handler(e519.ToString());
            }

            return a;
        }

        string boolLine(int lineNumber, bool b)
        {
            string item = EMPTY;

            switch(lineNumber)
            {
                case 2: // add_ID
                    if (b)
                    {
                        item = "-#";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                case 3: // case_sensitive
                    if (b)
                    {
                        item = ZERO;
                    }
                    else
                    {
                        item = "-f";
                    }

                    break;
                case 4: // report_ID
                    if (b)
                    {
                        item = "-!";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                case 8: // descending
                    if (b)
                    {
                        item = "-r";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                case 9: // loud
                    if (b)
                    {
                        item = ZERO;
                    }
                    else
                    {
                        item = "-s";
                    }

                    break;
                case 10: // carriage_return
                    if (b)
                    {
                        item = "-CRLF";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                case 12: // brackets
                    if (b)
                    {
                        item = "-B";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                case 13: // replace_ampersand
                    if (b)
                    {
                        item = ZERO;
                    }
                    else
                    {
                        item = "-A-";
                    }

                    break;
                case 14: // strictly_check
                    if (b)
                    {
                        item = "-S";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                case 17: // insert_both_bytes_and_nibbles
                    if (b)
                    {
                        item = "-N";
                    }
                    else
                    {
                        item = ZERO;
                    }

                    break;
                default:
                    break;
            }

            return item;
        }
/*
1: 40		lines
2: -#		-#
3: 0		-f
4: 0		-!
5: text.tmp	hetn.txt
6: sutai.xml	sutai.xml
7: 2		MS932
8: 0		-r
9: 0		-s
10:-CRLF		-CRLF
11:2		decimals
12:0		-B
13:0		-A-
14:0		-S
15:0        exclamation
16:0        33
17:0        -N
*/
        public void producingText(string parameters_text, string new_name, string xml_name, int encoding, int joint_type, int line_count, int manager, char joint, bool add_ID, bool brackets, bool carriage_return, bool case_sensitive, bool descending, bool insert_both_bytes_and_nibbles, bool loud, bool replace_ampersand, bool report_ID, bool strictly_check)
        {
            int joint_value = (int)joint;

            try
            {
                StreamWriter file = new StreamWriter(parameters_text, NO_APPENDING, Encoding.Default);
                file.Write(line_count); file.WriteLine("\t\tlines"); // Line-1
                file.Write(boolLine(2, add_ID)); file.WriteLine("\t\t-#"); // Line-2
                file.Write(boolLine(3, case_sensitive)); file.WriteLine("\t\t-f"); // Line-3
                file.Write(boolLine(4, report_ID)); file.WriteLine("\t\t-!"); // Line-4
                file.Write(new_name); file.WriteLine("\thetn.txt"); // Line-5
                file.Write(xml_name); file.WriteLine("\tsutai.xml"); // Line-6
                file.Write(encoding); file.WriteLine("\t\tMS932"); // Line-7 (1: EUC-JP. 2: Shift_JIS. 3: UTF-8)
                file.Write(boolLine(8, descending)); file.WriteLine("\t\t-r"); // Line-8
                file.Write(boolLine(9, loud)); file.WriteLine("\t\t-s"); // Line-9
                file.Write(boolLine(10, carriage_return)); file.WriteLine("\t\t-CRLF"); // Line-10
                file.Write(manager); file.WriteLine("\t\tdecimals"); // Line-11 (0: PHRASES. 1: INTEGERS. 2: FLOATING_POINT_NUMBERS)
                file.Write(boolLine(12, brackets)); file.WriteLine("\t\t-B"); // Line-12
                file.Write(boolLine(13, replace_ampersand)); file.WriteLine("\t\t-A-"); // Line-13
                file.Write(boolLine(14, strictly_check)); file.WriteLine("\t\t-S"); // Line-14
                file.Write(joint_type); file.WriteLine("\t\texclamation"); // Line-15 (0: EXCLAMATION_JOINT. 1: NIBBLE_JOINT. 2: BYTE_JOINT)
                file.Write(joint_value); file.WriteLine("\t\tjoint"); // Line-16
                file.Write(boolLine(17, insert_both_bytes_and_nibbles)); file.WriteLine("\t\t-N"); // Line-17
                file.Close();
            }
            catch (IOException e369)
            {
                Error.handler( e369.ToString() );
                return;
            }
            catch (Exception e370)
            {
                Error.handler( e370.ToString() );
                return;
            }

        }

        public PutText()
        {
        }

    }
}
